
﻿/*
 * Method gdReturnCapabilities()- Returns a list of "capabilities" for       * nsgd.                        
 * 
 */

static int gdReturnCapabilities() {
  printf("Current capabilities include the following: HAVE_TRUECOLOR, HAVE_LIBZ, HAVE_GD_GIF, HAVE_GD_JPEG, HAVE_GD_PNG, HAVE_GD_XPM, HAVE_GD_XBM, HAVE_GD_PNG");
  
  return TCL_OK;
}

/*
 *
 * Method tclGdDashedLineCmd() - Creates a dashed line.
 *
 */

static int tclGdDashedLineCmd(Tcl_Interp * interp, ClientData clientData,  int argc, Tcl_Obj * CONST objv[], char* cmd) 
{
  gdImagePtr im;
  int color, x1, y1, x2, y2;
  
  GetImage(im, 2);
  GetColor(&color, 3);
  GetInt(&x1, 4);
  GetInt(&y1, 5);
  GetInt(&x2, 6);
  GetInt(&y2, 7);
  
  gdImageDashedLine(im, x1, y1, x2, y2, color);
  return TCL_OK;  
  
}

/*
*
* Method tclGdCharCmd - Method to write a single character rather than  * a string.
*
*/

static int tclGdCharCmd(Tcl_Interp * interp, ClientData clientData, int argc, Tcl_Obj * CONST objv[], char* cmd) 
{
  gdImagePtr im;
  char *fontStr, *upStr;
  int color, x, y, c;
  gdFontPtr font = NULL;
  int up_p = 0;
  
  GetImage(im, 2);
  GetColor(&color, 3);
  GetInt(&x, 5);
  GetInt(&y, 6);
  GetInt(&c, 7);
  
  fontStr = Tcl_GetString(objv[4]);
  
  font = tagToFont(fontStr);
  
  if (font == NULL) {
    return TCL_ERROR;
  }
  
  if (argc == 9) {
    upStr = Tcl_GetString(objv[8]);
    if (!strcmp(upStr, "up")) {
      up_p = 1;
    } else {
      return TCL_ERROR;
    }
  }
  
  if (up_p == 1) {
    gdImageCharUp(im, font, x, y, c, color);
  } else {
    gdImageChar(im, font, x, y, c, color);
  }
  
  return TCL_OK;
  
}

/*
static int gdCtx(Tcl_Interp *interp, ClientData clientData , int argc, Tcl_Obj *CONST objv[], char* cmd)
{

  gdIOCtx *in;  
  
  gdImageCreateFromGdCtx(*in);

}
*/

/* 
* Method gdPtr() - This method is partly done, but needs more code   
* added to it, so that it works with all image types.
*
*/

static int gdPtr(Tcl_Interp *interp, ClientData clientData , int argc, Tcl_Obj *CONST objv[], char* cmd)
{
  
  gdImagePtr im;
  int size;
  
  GetImage(im,2);
  GetInt(&size,4);
  
  gdImageCreateFromGdPtr(size, im);
  
}

/*
* tclGdCreateFromPtr() - Method to create from pointer.
*
*/

static int tclGdCreateFromPtr(Tcl_Interp *interp, ClientData clientData , int argc, Tcl_Obj *CONST objv[], char* cmd)
{
  gdImagePtr im;
  int size;  
  
  GetImage(im,2);
  GetInt(&size,4);
  
  gdImageCreateFromGdPtr(size, im);  

  return TCL_OK;
  
}

/*
static int tclGdCreateFromCtx(Tcl_Interp *interp, ClientData clientData , int argc, Tcl_Obj *CONST objv[], char* cmd)
{
  
  gdIOCtx *in;
  
  gdImageCreateFromGd2Ctx(*in);
  
}
*/

/*
static int gdAnimatedGif(Tcl_Interp * interp, ClientData clientData,  int argc, Tcl_Obj * CONST objv[], char* cmd)
{
  FILE *filePtr;
  ClientData clientdata;
  gdImagePtr im;
  int GlobalCM, Loops;
  
  GetImage(im, 2);
  GetInt(&GlobalCM, 4);
  GetInt(&Loops, 5);
  filePtr = (FILE *) clientdata;
  
  gdImageGifAnimBegin(im, filePtr, GlobalCM, Loops);
  
  return TCL_OK;
  
}
*/


static int tclGdText16Cmd(Tcl_Interp *interp, ClientData clientData , int argc, Tcl_Obj *CONST objv[], char* cmd) 
{
  gdImagePtr im;
  int color, x, y;
  char *fontStr, *upStr;
  gdFontPtr font = NULL;
  int len, up_p = 0;
  unsigned short *str;
  
  GetImage(im, 2);
  GetColor(&color, 3);
  GetInt(&x, 5);
  GetInt(&y, 6);
  
  str = (unsigned short *)Tcl_GetStringFromObj(objv[7], &len);
  fontStr = Tcl_GetString(objv[4]);
  
  font = tagToFont(fontStr);
  
  if (font == NULL) {
    return TCL_ERROR;
  }
  
  if (argc == 9) {
    upStr = Tcl_GetString(objv[8]);
    if (!strcmp(upStr, "up")) {
      up_p = 1;
    } else {
      return TCL_ERROR;
    }
  }
    
  if (up_p == 1) {
    gdImageStringUp16(im, font, x, y, str, color);
  } else {
    gdImageString16(im, font, x, y, str, color);
  }
  
  return TCL_OK;
}

static int tclGdTextFTCmd(Tcl_Interp * interp, ClientData clientData,  int argc, Tcl_Obj * CONST objv[], char* cmd) 
{
  /* gd gdhandle color fontpathname size angle x y string */
  gdImagePtr im = NULL;
  int color, x, y;
  double ptsize, angle;
  char *error, buf[32], *font;
  int i, brect[8], len;
  char *str;
  
  /* Get the image pointer. (an invalid or null arg[2] will result in string
     size calculation but no rendering */
  if (objv[2] != NULL) {
    im = Tcl_GetGDImage(objv[2]);
  }
  
  GetColor(&color, 3);
  GetDouble(&ptsize, 5);
  GetDouble(&angle, 6); // in radians
  GetInt(&x, 7);
  GetInt(&y, 8);
  
  str = Tcl_GetStringFromObj(objv[9], &len);
  font = Tcl_GetString(objv[4]);
  
  error =
    gdImageStringFT(im, brect, color, font, ptsize, angle, x, y, str);
  
  if (error) {
    Tcl_SetResult(interp, error, TCL_VOLATILE);
    return TCL_ERROR;
  }
  for (i = 0; i < 8; i++) {
    sprintf(buf, "%d", brect[i]);
    Tcl_AppendElement(interp, buf);
  }
  return TCL_OK;
}


