#ifndef _DEFS_
#define _DEFS_

#include <elf.h>

#define Elf_Word Elf32_Word


#define Elf_Half Elf32_Half
#define Elf_Addr Elf32_Addr
#define Elf_Rel Elf32_Rel
#define Elf_Dyn Elf32_Dyn
#define Elf_Phdr Elf32_Phdr
#define Elf_Rela Elf32_Rela
#define Elf_Sym Elf32_Sym
#define Elf_Verneed Elf32_Verneed
#define Elf_Verdef Elf32_Verdef
#define Elf_Versym Elf32_Versym
#define Elf_Vernaux Elf32_Vernaux
#define Elf_Verdaux Elf32_Verdaux
#define Elf_Ehdr Elf32_Ehdr
#define Elf_Off Elf32_Off

#define ELF_ST_INFO ELF32_ST_INFO
#define ELF_ST_BIND ELF32_ST_BIND
#define ELF_ST_TYPE ELF32_ST_TYPE

#define ELF_R_SYM ELF32_R_SYM
#define ELF_R_TYPE ELF32_R_TYPE

#define Elf_Hashelt int
#define atomic_add_int(P, V)		(*(u_int *)(P) += (V))
#define	atomic_add_acq_int		atomic_add_int
#define	atomic_add_rel_int		atomic_add_int
#define	atomic_cmpset_acq_int		atomic_cmpset_int
#define _rtld_error printf


#define	ELF_TARG_CLASS  ELFCLASS32
#define	ELF_TARG_DATA	ELFDATA2LSB
#define	ELF_TARG_MACH	EM_386
#define	MAP_NOCORE	 0x00020000

#define PAGE_SIZE	4096
#define PAGE_MASK	PAGE_SIZE - 1
#define trunc_page(x)	((x) & ~(PAGE_MASK))
#define round_page(x)	(((x) + PAGE_MASK) & ~(PAGE_MASK))

typedef Elf32_Word	Elf32_Size;
#define Elf_Size Elf32_Word


/*AUXINFO */
typedef struct {
	int	a_type;
	union {
		long	a_val;
		void	*a_ptr;
		void	(*a_fcn)(void);
	} a_un;
} Elf32_Auxinfo;

/* Values for a_type. */
#define	AT_NULL		0	/* Terminates the vector. */
#define	AT_IGNORE	1	/* Ignored entry. */
#define	AT_EXECFD	2	/* File descriptor of program to load. */
#define	AT_PHDR		3	/* Program header of program already loaded. */
#define	AT_PHENT	4	/* Size of each program header entry. */
#define	AT_PHNUM	5	/* Number of program header entries. */
#define	AT_PAGESZ	6	/* Page size in bytes. */
#define	AT_BASE		7	/* Interpreter's base address. */
#define	AT_FLAGS	8	/* Flags (unused for i386). */
#define	AT_ENTRY	9	/* Where interpreter should transfer control. */
#define	AT_BRK		10	/* Starting point for sbrk and brk. */
#define	AT_DEBUG	11	/* Debugging level. */
#define	AT_NOTELF	10	/* Program is not ELF ?? */
#define	AT_UID		11	/* Real uid. */
#define	AT_EUID		12	/* Effective uid. */
#define	AT_GID		13	/* Real gid. */
#define	AT_EGID		14	/* Effective gid. */
#define	AT_COUNT	15	/* Count of defined aux entry types. */


#define Elf_Auxinfo Elf32_Auxinfo
/* END AUXINFO */


#define RTLD_MODEMASK 0x3

#define	VER_NDX_LOCAL	0
#define	VER_NDX_GLOBAL	1
#define VER_NDX_GIVEN	2

#define VER_NDX_HIDDEN	(1u << 15)
#define VER_NDX(x)	((x) & ~(1u << 15))

#define	VER_NEED_CURRENT	1
#define VER_NEED_WEAK	(1u << 15)
#define VER_NEED_HIDDEN	VER_NDX_HIDDEN
#define VER_NEED_IDX(x)	VER_NDX(x)

#define VER_DEF_IDX(x)	VER_NDX(x)


#define ELFHINTS_MAGIC	0x746e6845

#define _PATH_ELF_HINTS	"/var/run/ld-elf.so.hints"

#define RTLD_STATIC_TLS_EXTRA 256
#define MADV_CORE 9

#endif
