#!/usr/bin/env tclsh

set dir [pwd]
set dir [string range $dir 0 end-15]
set ::auto_path "$::auto_path $dir"

package require Tk
package require Tcl 8.5
package require tktopdf

wm geometry . =400x600

. configure -bg green

canvas .c1 -width 200 -height 250 -borderwidth 2 -relief raised \
        -highlightthickness 0
canvas .c2 -width 100 -height 100 -background red
button .b1 -text button -font {Helvetica 10}

.c2 create window 30 30 -anchor nw -window .b1
.c1 create window 90 245 -anchor nw -window .c2
.c1 create rectangle 10 10 50 80 -fill red -outline green -width 4 -dash {_.} -dashoffset 0
.c1 create rectangle 110 10 150 80 -fill red -outline green -width 1 -dash {8 4} -dashoffset 0
.c1 create polygon 10 100 80 100 80 250 10 250 220 220 \
        -width 5 -joinstyle "bevel" -fill blue -outline red \
        -smooth bezier
.c1 create arc 200 200 300 300 -start 30 -extent 300 -fill green -outline violet -width 4 \
        -style chord
.c1 create line 200 20 240 40 240 100 280 150 300 100 -fill blue -width 10 \
        -smooth bezier -cap round
.c1 create text 50 300 -text ABCdef -font {Helvetica 15} -anchor s

place .c1 -x 0 -y 0

tktopdf::startFile -file "canvas_rotatedandscaled.pdf" \
        -scalex 2.0 -scaley 1.75 \
        -marginleft 0.5i -margintop 0.25i -marginright 0.5i -marginbottom 0.25i \
        -pagex 0 -pagey 0 \
        -rotatexy 1 -pagewidth 400 -pageheight 600
tktopdf::exportWindow .c1
tktopdf::endFile

tktopdf::startFile -file "canvas_little.pdf" \
        -scalex 1.0 -scaley 1.0 \
        -marginleft 0.5i -margintop 0.5i -marginright 0.5i -marginbottom 0.5i \
        -pagex 0 -pagey 0 \
        -rotatexy 0 -pagewidth 400 -pageheight 600
tktopdf::exportWindow .c1
tktopdf::endFile
