#!/usr/bin/env tclsh

set dir [pwd]
set dir [string range $dir 0 end-15]
set ::auto_path "$::auto_path $dir"

package require Tk
package require Tcl 8.5
package require tktopdf

wm geometry . =400x600

. configure -bg green

label .lab1 \
    -relief raised \
    -borderwidth 2 \
    -padx 5 \
    -pady 5 \
    -anchor ne \
    -highlightthickness 2 \
    -justify left \
    -wraplength 53 \
    -text "This is a long text with wraplength 53" \
    -font {Helvetica 10}

set val {first second blablablabla}

listbox .listx \
    -width 5 \
    -height 4 \
    -borderwidth 4 \
    -bg green \
    -selectbackground red \
    -selectborderwidth 6 \
    -selectmode multiple \
    -font {Arial 28} \
    -highlightthickness 20

.listx insert 0 firstX
.listx insert 1 second
.listx insert 2 blablalblabal
.listx insert 3 another blblblb:)

.listx itemconfigure 0 -background white -foreground green
.listx itemconfigure 1 -background red -foreground blue
.listx selection set 0 1

pack .lab1
pack .listx

tktopdf::startFile -file "labellist_wholepage.pdf" \
        -scalex 1.0 -scaley 1.00 \
        -marginleft 0.5i -margintop 0.25i -marginright 0.5i -marginbottom 0.25i
tktopdf::exportWindow .
tktopdf::endFile
